function sanitize(text) {
    const decoder = document.createElement('div')
    decoder.textContent = text;
    const sanitized = decoder.innerHTML;
    return sanitized;
}
function addProject(title, id, username, date, type, endpoint) {
    title = sanitize(title);
    id = sanitize(id);
    username = sanitize(username);
    type = sanitize(type);

    url = new URL(endpoint).origin;

    return `
        <div class="vmeta">
        <a href="/${type}/${id}" >
            <div class="thumb" style='--thumb-source: url(${url}/raw?sub=thumbs&id=${id})'></div>
            <div class="big"><b>${title}</b></div>
        </a>
        <div><a href="/users/${username}">${username}</a></div>
        <div class='date'>${(new Date(date) + '').split('GMT')[0]}</div>
        </div>
    `;
}
function addComment(username, content) {
    content = sanitize(content);
    username = sanitize(username);

    return `
        <div class="comment">
            <b><a href="/users/${username}">${username}</a> </b>
            <p>${content}</p>
        </div>
    `;
}

for (let elem of document.querySelectorAll('.list-wrapper')) {
    let endpoint = elem.getAttribute("endpoint");
    let type = elem.getAttribute("type");

    elem.innerHTML += `<a class='button lmore'>Load More</a>`;
    let button = elem.querySelector('.button.lmore');

    elem.innerHTML += `<div class='bleh'></div>`;

    button.onclick = async function () {
        let page = elem.getAttribute('page') * 1 || 0;
        elem.setAttribute('page', page + 1);
        let dat = await fetch(`${endpoint}&page=${page}`).then((x) =>
            x.json(),
        );
        
        if (dat.length == 0) {
            elem.setAttribute('page', '9999999999');
            elem.querySelector('.bleh').remove();
            return;
        }
        for (let entry of dat) {
            if (type == 'comment') {
                elem.querySelector('div').innerHTML += addComment(entry.username, entry.content)
            } else {
                elem.querySelector('div').innerHTML += addProject(entry.title, entry.id, entry.username, entry.date, type, endpoint)
            }
        }
    }

    let obv = new IntersectionObserver((entries) => {
        entries.forEach((entry) => {
            if (entry.isIntersecting) button.click();
        })
    });

    obv.observe(elem.querySelector('.bleh'));

    button.click();
}
